Index: pjproject/trunk/pjproject-vs8.sln
===================================================================
--- pjproject/trunk/pjproject-vs8.sln	(revision 5354)
+++ pjproject/trunk/pjproject-vs8.sln	(revision 5358)
@@ -101,5 +101,5 @@
 	ProjectSection(ProjectDependencies) = postProject
 		{F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858} = {F0DBAA03-1BA3-4E3B-A2CA-727E3D3AB858}
-		{6AC9B65F-0862-4A5C-8A9D-141516993130} = {6AC9B65F-0862-4A5C-8A9D-141516993130}
+		{740DDEB9-D47C-4A83-A585-A366B6965410} = {740DDEB9-D47C-4A83-A585-A366B6965410}
 		{E53AA5FF-B737-40AA-BD13-387EFA99023D} = {E53AA5FF-B737-40AA-BD13-387EFA99023D}
 		{9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37} = {9CA0FDFB-2172-41FC-B7F1-5CE915EDCB37}
@@ -139,5 +139,5 @@
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsua2_lib", "pjsip\build\pjsua2_lib.vcproj", "{B82CDD25-6903-430E-BD38-D8129A2015C1}"
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "liblibyuv", "third_party\build\libyuv\liblibyuv.vcproj", "{6AC9B65F-0862-4A5C-8A9D-141516993130}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "libyuv", "third_party\build\yuv\libyuv.vcproj", "{740DDEB9-D47C-4A83-A585-A366B6965410}"
 EndProject
 Global
@@ -3188,82 +3188,82 @@
 		{B82CDD25-6903-430E-BD38-D8129A2015C1}.Release-Static|x64.ActiveCfg = Release-Static|x64
 		{B82CDD25-6903-430E-BD38-D8129A2015C1}.Release-Static|x64.Build.0 = Release-Static|x64
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Pocket PC 2003 (ARMV4).ActiveCfg = Debug|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Pocket PC 2003 (ARMV4).Build.0 = Debug|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Pocket PC 2003 (ARMV4).Deploy.0 = Debug|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Smartphone 2003 (ARMV4).ActiveCfg = Debug|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Smartphone 2003 (ARMV4).Build.0 = Debug|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Smartphone 2003 (ARMV4).Deploy.0 = Debug|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Win32.ActiveCfg = Debug|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Win32.Build.0 = Debug|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Debug|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Debug|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Debug|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Debug|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug|x64.ActiveCfg = Debug|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Pocket PC 2003 (ARMV4).ActiveCfg = Debug-Dynamic|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Pocket PC 2003 (ARMV4).Build.0 = Debug-Dynamic|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Pocket PC 2003 (ARMV4).Deploy.0 = Debug-Dynamic|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Smartphone 2003 (ARMV4).ActiveCfg = Debug-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Smartphone 2003 (ARMV4).Build.0 = Debug-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Smartphone 2003 (ARMV4).Deploy.0 = Debug-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Win32.ActiveCfg = Debug-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Win32.Build.0 = Debug-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Dynamic|x64.ActiveCfg = Debug-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Pocket PC 2003 (ARMV4).ActiveCfg = Debug-Static|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Pocket PC 2003 (ARMV4).Build.0 = Debug-Static|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Pocket PC 2003 (ARMV4).Deploy.0 = Debug-Static|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Smartphone 2003 (ARMV4).ActiveCfg = Debug-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Smartphone 2003 (ARMV4).Build.0 = Debug-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Smartphone 2003 (ARMV4).Deploy.0 = Debug-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Win32.ActiveCfg = Debug-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Win32.Build.0 = Debug-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Debug-Static|x64.ActiveCfg = Debug-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Pocket PC 2003 (ARMV4).ActiveCfg = Release|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Pocket PC 2003 (ARMV4).Build.0 = Release|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Pocket PC 2003 (ARMV4).Deploy.0 = Release|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Smartphone 2003 (ARMV4).ActiveCfg = Release|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Smartphone 2003 (ARMV4).Build.0 = Release|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Smartphone 2003 (ARMV4).Deploy.0 = Release|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Win32.ActiveCfg = Release|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Win32.Build.0 = Release|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Release|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Release|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Release|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Release|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release|x64.ActiveCfg = Release|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Pocket PC 2003 (ARMV4).ActiveCfg = Release-Dynamic|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Pocket PC 2003 (ARMV4).Build.0 = Release-Dynamic|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Pocket PC 2003 (ARMV4).Deploy.0 = Release-Dynamic|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Smartphone 2003 (ARMV4).ActiveCfg = Release-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Smartphone 2003 (ARMV4).Build.0 = Release-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Smartphone 2003 (ARMV4).Deploy.0 = Release-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Win32.ActiveCfg = Release-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Win32.Build.0 = Release-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Dynamic|x64.ActiveCfg = Release-Dynamic|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Pocket PC 2003 (ARMV4).ActiveCfg = Release-Static|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Pocket PC 2003 (ARMV4).Build.0 = Release-Static|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Pocket PC 2003 (ARMV4).Deploy.0 = Release-Static|Pocket PC 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Smartphone 2003 (ARMV4).ActiveCfg = Release-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Smartphone 2003 (ARMV4).Build.0 = Release-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Smartphone 2003 (ARMV4).Deploy.0 = Release-Static|Smartphone 2003 (ARMV4)
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Win32.ActiveCfg = Release-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Win32.Build.0 = Release-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Release-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Release-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Release-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Release-Static|Win32
-		{6AC9B65F-0862-4A5C-8A9D-141516993130}.Release-Static|x64.ActiveCfg = Release-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Pocket PC 2003 (ARMV4).ActiveCfg = Debug|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Pocket PC 2003 (ARMV4).Build.0 = Debug|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Pocket PC 2003 (ARMV4).Deploy.0 = Debug|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Smartphone 2003 (ARMV4).ActiveCfg = Debug|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Smartphone 2003 (ARMV4).Build.0 = Debug|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Smartphone 2003 (ARMV4).Deploy.0 = Debug|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Win32.ActiveCfg = Debug|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Win32.Build.0 = Debug|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Debug|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Debug|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Debug|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Debug|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug|x64.ActiveCfg = Debug|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Pocket PC 2003 (ARMV4).ActiveCfg = Debug-Dynamic|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Pocket PC 2003 (ARMV4).Build.0 = Debug-Dynamic|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Pocket PC 2003 (ARMV4).Deploy.0 = Debug-Dynamic|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Smartphone 2003 (ARMV4).ActiveCfg = Debug-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Smartphone 2003 (ARMV4).Build.0 = Debug-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Smartphone 2003 (ARMV4).Deploy.0 = Debug-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Win32.ActiveCfg = Debug-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Win32.Build.0 = Debug-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Debug-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Dynamic|x64.ActiveCfg = Debug-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Pocket PC 2003 (ARMV4).ActiveCfg = Debug-Static|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Pocket PC 2003 (ARMV4).Build.0 = Debug-Static|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Pocket PC 2003 (ARMV4).Deploy.0 = Debug-Static|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Smartphone 2003 (ARMV4).ActiveCfg = Debug-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Smartphone 2003 (ARMV4).Build.0 = Debug-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Smartphone 2003 (ARMV4).Deploy.0 = Debug-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Win32.ActiveCfg = Debug-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Win32.Build.0 = Debug-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Debug-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Debug-Static|x64.ActiveCfg = Debug-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Pocket PC 2003 (ARMV4).ActiveCfg = Release|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Pocket PC 2003 (ARMV4).Build.0 = Release|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Pocket PC 2003 (ARMV4).Deploy.0 = Release|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Smartphone 2003 (ARMV4).ActiveCfg = Release|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Smartphone 2003 (ARMV4).Build.0 = Release|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Smartphone 2003 (ARMV4).Deploy.0 = Release|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Win32.ActiveCfg = Release|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Win32.Build.0 = Release|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Release|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Release|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Release|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Release|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release|x64.ActiveCfg = Release|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Pocket PC 2003 (ARMV4).ActiveCfg = Release-Dynamic|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Pocket PC 2003 (ARMV4).Build.0 = Release-Dynamic|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Pocket PC 2003 (ARMV4).Deploy.0 = Release-Dynamic|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Smartphone 2003 (ARMV4).ActiveCfg = Release-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Smartphone 2003 (ARMV4).Build.0 = Release-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Smartphone 2003 (ARMV4).Deploy.0 = Release-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Win32.ActiveCfg = Release-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Win32.Build.0 = Release-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Release-Dynamic|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Dynamic|x64.ActiveCfg = Release-Dynamic|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Pocket PC 2003 (ARMV4).ActiveCfg = Release-Static|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Pocket PC 2003 (ARMV4).Build.0 = Release-Static|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Pocket PC 2003 (ARMV4).Deploy.0 = Release-Static|Pocket PC 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Smartphone 2003 (ARMV4).ActiveCfg = Release-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Smartphone 2003 (ARMV4).Build.0 = Release-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Smartphone 2003 (ARMV4).Deploy.0 = Release-Static|Smartphone 2003 (ARMV4)
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Win32.ActiveCfg = Release-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Win32.Build.0 = Release-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Windows Mobile 5.0 Pocket PC SDK (ARMV4I).ActiveCfg = Release-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Windows Mobile 5.0 Smartphone SDK (ARMV4I).ActiveCfg = Release-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Windows Mobile 6 Professional SDK (ARMV4I).ActiveCfg = Release-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|Windows Mobile 6 Standard SDK (ARMV4I).ActiveCfg = Release-Static|Win32
+		{740DDEB9-D47C-4A83-A585-A366B6965410}.Release-Static|x64.ActiveCfg = Release-Static|Smartphone 2003 (ARMV4)
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution